format compact  

% ------------- Simulation parameters --------------------  

tsim_ILC=20;                        % total simulation time
tsamp_ILC=0.010;                    % sample time
ref_period=10;    
time_ILC=[0:tsamp_ILC:tsim_ILC-tsamp_ILC]';


% ---  To describe transfer functions in discrete and continous time  
  
z=tf([1 0],1,tsamp_ILC);     
s=tf([1 0],1);

% ---- Refrence trajectory -------------------


pos_Reference_ILC=square(2*pi/ref_period*time_ILC);

  % filter ref_signal to smoother response
  [B_ref,A_ref]=tfdata(c2d( 1/(s/4+1),tsamp_ILC),'v');
  pos_Reference_ILC_sq=pos_Reference_ILC;
  pos_Reference_ILC=filter(B_ref,A_ref,pos_Reference_ILC);

  %plot(time_ILC,pos_Reference_ILC_sq,time_ILC,pos_Reference_ILC)
  
  
idx_ILC=1;
correction_ILC=zeros(size(pos_Reference_ILC));

%------ Heuristic design -------------

Qd=c2d( 1/(s/15+1),tsamp_ILC);
Ld=0.4*z^20;

%  2040923 : Qd=c2d( 1/(s/10+1),tsamp_ILC);
%  2040923 : Ld=0.6*z^25;
%  Qd=c2d( 1/(s/1+1),tsamp_ILC);
%Ld=0.2*z^5;

%--- corr at ctrl ---
%
%Qd=c2d( 1/(s/1+1),tsamp_ILC);
%Ld=1/c2d(s*250/(s/0.01+1)*(1/(s/3+1))^2,tsamp_ILC ,'matched');

%-- model matched Ld----
% Qd=c2d( 1/(s/1+1),tsamp_ILC);
% ww=2.5; tmp=tf(ww^2,[1 2*0.42*ww ww^2]); 
% Ld=1/c2d(tmp,tsamp_ILC,'matched');

%  bode(ILC_pidDCsim_1,tmp,Ld); legend

[Ld_B,Ld_A] = tfdata(Ld,'v');
[Qd_B,Qd_A] = tfdata(Qd,'v');

% ILC iterations

err=[]
